const InformeMoi = require('./InformeMoi.js');
const DatabaseCommand = require('./DatabaseCommand.js');
const CommandVoteParser = require('./CommandVoteParser.js');
const CommandQui = require('./CommandQui.js');
const CommandPourquoi = require('./CommandPourquoi.js');
const CommandInfoCovid = require('./CommandInfoCovid.js');
const OpenAI = require('./OpenAI.js');


class CommandParser {

    constructor(client, voteParser) {
        this.client = client;
        this.informeMoi = new InformeMoi(client);
        this.databaseCommand = new DatabaseCommand(client);
        this.commandVoteParser = new CommandVoteParser(voteParser);
        this.commandQui = new CommandQui(client);
        this.commandPourquoi = new CommandPourquoi(client);
        this.commandInfoCovid = new CommandInfoCovid(client);
        this.openAI = new OpenAI(client);
    }


    parse(message) {
        if (message.author.id !== this.client.application.id) {
            this.informeMoi.parse(message);
            this.databaseCommand.parse(message);
            this.commandVoteParser.parse(message);
            this.commandQui.parse(message);
            this.commandPourquoi.parse(message);
            this.commandInfoCovid.parse(message);
        }
        //this.openAI.parse(message);

    }
}

module.exports = CommandParser;
