
const {OPENAI_API_KEY} = require('../config.json');
const { Configuration, OpenAIApi } = require("openai");
const configuration = new Configuration({
  apiKey: OPENAI_API_KEY,
});

const COMPLOBOT_LINE_PREFIX = "Complobot (façon complotiste):";
/*
class Message{
    constructor(message, listMessage){
        this.content = message.content;
        this.user = message.author.username;
        this.id = message.id;
        this.parent = null;
        if(message.reference && message.reference.messageId){
            for(let i = 0; i < listMessage.length ; i++){
                let m = listMessage[i];
                if(m.id === message.reference.messageId){
                    this.parent = m;
                    break;
                }
            }
        }
       
    }

    toString(){
        return `${this.user}: ${this.content}\n`;
    }

    dialogue(){
        let item = this;
        let dialog = "";
        while(item !== null){
            let itemStr = item.toString();
            let newStr =  itemStr + dialog;

            if(newStr > 950){
                item = null;
                break;
            }else{
                dialog = newStr;
                item = item.parent;
            }
        }

        dialog = `Ecrit le dialogue de Complobot.\n${dialog}${COMPLOBOT_LINE_PREFIX}`;

        return dialog;
    }

}

*/
class OpenAI{
    constructor(client) {
        this.client = client;
        this.openai = new OpenAIApi(configuration);
        this.questionRE = new RegExp('^[^?]+\\?$');
     //   this.messages = [];


    }

    async getRandomTheorieOpenAI(subject){
        const completion = await this.openai.createCompletion("text-davinci-002", {
            prompt: `Ecrit une théorie du complot sur ${subject}.`,
            temperature: 0.7,
            max_tokens: 500
          });
          return completion.data.choices[0].text ;
    }

    async getRandomAnswerOpenAI(question){
        const completion = await this.openai.createCompletion("text-davinci-002", {
            prompt: `Répond de manière complotiste à la question "${question}"`,
            temperature: 0.7,
            max_tokens: 500
          });
          return completion.data.choices[0].text ;
    }
/*
    async getRandomDialogOpenAI(message){
        const promptInput = message.dialogue();
        const completion = await this.openai.createCompletion("text-davinci-002", {
            prompt:promptInput ,
            temperature: 0.7,
            max_tokens: 500
          });
        const reponse = completion.data.choices[0].text;
        return reponse;
    }
*/
    parse(discordMessage){
       /*const message = new Message(discordMessage, this.messages);
        
	    this.messages.push(message);
        
        if(this.messages.length > 200){
            this.messages.shift();
        }
*/
        if(discordMessage.author.id === this.client.application.id){
            return;
        }

        if(discordMessage.content.toLowerCase().startsWith('informe moi sur ')){
            this.getRandomTheorieOpenAI(discordMessage.content).then(reponse=>{
                discordMessage.reply(reponse);
            })
        }else if(this.questionRE.test(discordMessage.content)){
            /*if(message.parent !== null){
                this.getRandomDialogOpenAI(message).then(reponse=>{
                    discordMessage.reply(reponse);
                });
            }else{*/
                this.getRandomAnswerOpenAI(discordMessage.content).then((reponse)=>{
                    discordMessage.reply(reponse);
                });
           // }
        }
        
    }
}

module.exports = OpenAI;
